#include	<u.h>
#include	<stdarg.h>
#include	<libc.h>
#include	<stdio.h>
#include	<auth.h>
#include	<fcall.h>
#include	"db.h"

/* Read the current data record into the data buffer.
 * Return a pointer to the null-terminated data buffer. */

char *
_db_readdat(DB *db)
{
	if (seek(db->datfd, db->datoff, SEEK_SET) == -1)
		exits("lseek error");

	if (read(db->datfd, db->datbuf, db->datlen) != db->datlen)
		exits("read error");
	if (db->datbuf[db->datlen - 1] != '\n')		/* sanity check */
		exits("missing newline");
	db->datbuf[db->datlen - 1] = 0;		/* replace newline with null */

	return(db->datbuf);		/* return pointer to data record */
}
