#include	<u.h>
#include	<libc.h>
#include	<db.h>

/* Use the undocmuented _db_hash() function to determine the hash
 * statistics of a database. */

void doit(char *);

main(int argc, char *argv[])
{
	if (argc != 2)

		exits("tstats <db>");

	doit(argv[1]);
	exits("");
}

long	cntr[NHASH_DEF];

void doit(char *pathname)
{
	DB		*db;
	char	key[IDXLEN_MAX], *ptr;
	hash_t	hash;
	int	i, nrec;

	if ( (db = db_open(pathname, O_RDONLY, 0)) == 0)
		exits("db_open error");
	nrec = 0;
	while ( (ptr = db_nextrec(db, key)) != 0) {
		nrec++;
		hash = _db_hash(db, key);
		cntr[hash]++;
	}
	print("total #records = %d\n", nrec);
	for (i = 0; i < NHASH_DEF; i++) {
		print("%3d: %6ld\n", i, cntr[i]);
	}

	if ( (i = _db_checkfree(db)) < 0)
		print("corrupted free list\n");
	else
		print("%d records on free list\n", i);

	exits("");
}
