#include "lib.h"
#include "phones.h"

char	**dialect = ph_am;
#ifndef HAVE_LIBDBM
void *dict;
#endif

#ifdef HAVE_LIBDBM
#include <ctype.h>
#include <db.h>

#include "dict.h"
#include "getargs.h"

#ifndef DICT_DIR		/* /lib/say/bDict.dat and /lib/say/bDict.idx */
#define DICT_DIR "/lib/say"
#endif

char	*dict_path = "b";

uchar *
dict_find(char *s, unsigned n)
{
	if(!n)
		n = strlen(s);
	if(dict) {
		char key[128], *data;
		int i;
		for(i=0;i<n+1;i++) key[i]=0;
		for(i = 0; i < n; i++)
			key[i] = islower(s[i]) ? toupper(s[i]) : s[i];
		data = db_fetch(dict, key);
		if(data) {
			uchar *w = malloc(strlen(data) + 1);
			strcpy((char*)w, data);
			return w;
		}
	}
	return nil;
}

static void
choose_dialect(void)
{
	uchar *word = dict_find("schedule", 0);
	if(word) {
		if(word[0] == SH)
			dialect = ph_br;
		else if(word[0] == S && word[1] == K)
			dialect = ph_am;
		free(word);
	}
}

int
dict_init(int argc, char *argv[])
{
	char	*buf;
	argc = getargs("Dictionary", argc, argv, "d", "", &dict_path, "Which dictionary [b|a]", nil);
	if(!help_only) {
		buf = malloc(strlen(DICT_DIR) + strlen("Dict") + strlen(dict_path) + 2);
		sprint(buf, "%sDict", dict_path);
		if((dict = db_open(buf, O_RDONLY, 00644)) == nil) {
			sprint(buf, "%s/%sDict", DICT_DIR, dict_path);
			dict = db_open(buf, O_RDONLY, 00644);
		}
		if(dict != nil) {
			dict_path = realloc(buf, strlen(buf) + 1);
			choose_dialect();
		}
	}
	return argc;
}

void
dict_term(void)
{
	if(dict)
		db_close(dict);
}

#else

uchar*
dict_find(char *s, unsigned n)
{
	USED(s); USED(n);
	return nil;
}

int
dict_init(int argc, char *argv[])
{
	USED(argv);
	return argc;
}

void
dict_term(void)
{
}
#endif
